/********************************************************************************
miniCalc Widget

Written by: Jorge Vilas
Copyright (c) 2006 Jorge Vilas. All Rights Reserved.

Version History:
1.0 (April 2006) - Initial Release
 ********************************************************************************/
include("JV.js");

var dropdownMenu = new Array();
var contextMenu = new Array();

function mainWindow_onContextMenu() {
	contextMenu[0].enabled = true;
	main_window.contextMenuItems = contextMenu;
}
var author = new MenuItem();
author = new MenuItem();
author.title = "About the Author";
author.onSelect = "AboutTheAuthor();";
contextMenu.push(author);

author = new MenuItem();
author.title = "Visit Website";
author.onSelect = "goWebsite();";
contextMenu.push(author);

author = new MenuItem();
author.title = "Make a Donation";
author.onSelect = "Donate();";
contextMenu.push(author);

main_window.contextMenuItems = contextMenu;
main_window.onContextMenu = "mainWindow_onContextMenu()";

maxLengthNum = 11;
maxLengthDec = 9;
var num = new Array(3);
num[0] = "0";
num[1] = "0";
num[2]  = 0;
var opr = new Array(2);
opr[0] = "";
opr[1] = "";
fpMult = 10000000000;
resetDisplay = false;
hasADec = false;
prefsChanged=false;
var winStatus = "min";
var skin = preferences.skinSel.value.replace(/ /g,"_");

function init() {
	displayValue.data = "0";
	setSkin();
	winSetup();
}
init();

function setSkin() {
	calcBody.src = "Resources/Images/" + skin + "/body.png";
	display.src = "Resources/Images/" + skin + "/display.png";
	btnmin.src = "Resources/Images/" + skin + "/btn_minup.png";
	btnmin.onMouseEnter = "btnmin.src='Resources/Images/" + skin + "/btn_mindn.png';";
	btnmin.onMouseExit = "btnmin.src='Resources/Images/" + skin + "/btn_minup.png';";
	copy.src = "Resources/Images/" + skin + "/copyup.png";
	copy.onMouseEnter = "copy.src='Resources/Images/" + skin + "/copydn.png';";
	copy.onMouseExit = "copy.src='Resources/Images/" + skin + "/copyup.png';";
	paste.src = "Resources/Images/" + skin + "/pasteup.png";
	paste.onMouseEnter = "paste.src='Resources/Images/" + skin + "/pastedn.png';";
	paste.onMouseExit = "paste.src='Resources/Images/" + skin + "/pasteup.png';";

	key1.src = "Resources/Images/" + skin + "/mrup.png";
	key1.onMouseEnter = "key1.src = 'Resources/Images/" + skin + "/mrdn.png';";
	key1.onMouseExit = "key1.src = 'Resources/Images/" + skin + "/mrup.png';";
	key2.src = "Resources/Images/" + skin + "/mcup.png";
	key2.onMouseEnter = "key2.src = 'Resources/Images/" + skin + "/mcdn.png';";
	key2.onMouseExit = "key2.src = 'Resources/Images/" + skin + "/mcup.png';";
	key3.src = "Resources/Images/" + skin + "/clrup.png";
	key3.onMouseEnter = "key3.src = 'Resources/Images/" + skin + "/clrdn.png';";
	key3.onMouseExit = "key3.src = 'Resources/Images/" + skin + "/clrup.png';";
	key4.src = "Resources/Images/" + skin + "/delup.png";
	key4.onMouseEnter = "key4.src = 'Resources/Images/" + skin + "/deldn.png';";
	key4.onMouseExit = "key4.src = 'Resources/Images/" + skin + "/delup.png';";
	key5.src = "Resources/Images/" + skin + "/m1up.png";
	key5.onMouseEnter = "key5.src = 'Resources/Images/" + skin + "/m1dn.png';";
	key5.onMouseExit = "key5.src = 'Resources/Images/" + skin + "/m1up.png';";
	key6.src = "Resources/Images/" + skin + "/m2up.png";
	key6.onMouseEnter = "key6.src = 'Resources/Images/" + skin + "/m2dn.png';";
	key6.onMouseExit = "key6.src = 'Resources/Images/" + skin + "/m2up.png';";
	key7.src = "Resources/Images/" + skin + "/percentup.png";
	key7.onMouseEnter = "key7.src = 'Resources/Images/" + skin + "/percentdn.png';";
	key7.onMouseExit = "key7.src = 'Resources/Images/" + skin + "/percentup.png';";
	key8.src = "Resources/Images/" + skin + "/switch_signup.png";
	key8.onMouseEnter = "key8.src = 'Resources/Images/" + skin + "/switch_signdn.png';";
	key8.onMouseExit = "key8.src = 'Resources/Images/" + skin + "/switch_signup.png';";
	key9.src = "Resources/Images/" + skin + "/7up.png";
	key9.onMouseEnter = "key9.src = 'Resources/Images/" + skin + "/7dn.png';";
	key9.onMouseExit = "key9.src = 'Resources/Images/" + skin + "/7up.png';";
	key10.src = "Resources/Images/" + skin + "/8up.png";
	key10.onMouseEnter = "key10.src = 'Resources/Images/" + skin + "/8dn.png';";
	key10.onMouseExit = "key10.src = 'Resources/Images/" + skin + "/8up.png';";
	key11.src = "Resources/Images/" + skin + "/9up.png";
	key11.onMouseEnter = "key11.src = 'Resources/Images/" + skin + "/9dn.png';";
	key11.onMouseExit = "key11.src = 'Resources/Images/" + skin + "/9up.png';";
	key12.src = "Resources/Images/" + skin + "/divideup.png";
	key12.onMouseEnter = "key12.src = 'Resources/Images/" + skin + "/dividedn.png';";
	key12.onMouseExit = "key12.src = 'Resources/Images/" + skin + "/divideup.png';";
	key13.src = "Resources/Images/" + skin + "/4up.png";
	key13.onMouseEnter = "key13.src = 'Resources/Images/" + skin + "/4dn.png';";
	key13.onMouseExit = "key13.src = 'Resources/Images/" + skin + "/4up.png';";
	key14.src = "Resources/Images/" + skin + "/5up.png";
	key14.onMouseEnter = "key14.src = 'Resources/Images/" + skin + "/5dn.png';";
	key14.onMouseExit = "key14.src = 'Resources/Images/" + skin + "/5up.png';";
	key15.src = "Resources/Images/" + skin + "/6up.png";
	key15.onMouseEnter = "key15.src = 'Resources/Images/" + skin + "/6dn.png';";
	key15.onMouseExit = "key15.src = 'Resources/Images/" + skin + "/6up.png';";
	key16.src = "Resources/Images/" + skin + "/multiplyup.png";
	key16.onMouseEnter = "key16.src = 'Resources/Images/" + skin + "/multiplydn.png';";
	key16.onMouseExit = "key16.src = 'Resources/Images/" + skin + "/multiplyup.png';";
	key17.src = "Resources/Images/" + skin + "/1up.png";
	key17.onMouseEnter = "key17.src = 'Resources/Images/" + skin + "/1dn.png';";
	key17.onMouseExit = "key17.src = 'Resources/Images/" + skin + "/1up.png';";
	key18.src = "Resources/Images/" + skin + "/2up.png";
	key18.onMouseEnter = "key18.src = 'Resources/Images/" + skin + "/2dn.png';";
	key18.onMouseExit = "key18.src = 'Resources/Images/" + skin + "/2up.png';";
	key19.src = "Resources/Images/" + skin + "/3up.png";
	key19.onMouseEnter = "key19.src = 'Resources/Images/" + skin + "/3dn.png';";
	key19.onMouseExit = "key19.src = 'Resources/Images/" + skin + "/3up.png';";
	key20.src = "Resources/Images/" + skin + "/subtractup.png";
	key20.onMouseEnter = "key20.src = 'Resources/Images/" + skin + "/subtractdn.png';";
	key20.onMouseExit = "key20.src = 'Resources/Images/" + skin + "/subtractup.png';";
	key21.src = "Resources/Images/" + skin + "/0up.png";
	key21.onMouseEnter = "key21.src = 'Resources/Images/" + skin + "/0dn.png';";
	key21.onMouseExit = "key21.src = 'Resources/Images/" + skin + "/0up.png';";
	key22.src = "Resources/Images/" + skin + "/decimalup.png";
	key22.onMouseEnter = "key22.src = 'Resources/Images/" + skin + "/decimaldn.png';";
	key22.onMouseExit = "key22.src = 'Resources/Images/" + skin + "/decimalup.png';";
	key23.src = "Resources/Images/" + skin + "/equalup.png";
	key23.onMouseEnter = "key23.src = 'Resources/Images/" + skin + "/equaldn.png';";
	key23.onMouseExit = "key23.src = 'Resources/Images/" + skin + "/equalup.png';";
	key24.src = "Resources/Images/" + skin + "/addup.png";
	key24.onMouseEnter = "key24.src = 'Resources/Images/" + skin + "/adddn.png';";
	key24.onMouseExit = "key24.src = 'Resources/Images/" + skin + "/addup.png';";
}

function winSetup() {
	main_window.height = 32;
	minCalc.visible = true;
	setMinwin();
	main_window.visible = true;
}

function setMinwin() {
	winStatus = "min";
	maxCalc.visible = false;
	main_window.height = 32;
	minCalc.visible = true;
	minimizedbar.src = "Resources/Images/" + skin + "/minibody.png";
	btnmax.src = "Resources/Images/" + skin + "/btn_maxup.png";
	btnmax.onMouseEnter = "btnmax.src='Resources/Images/" + skin + "/btn_maxdn.png'";
	btnmax.onMouseExit = "btnmax.src='Resources/Images/" + skin + "/btn_maxup.png'";
	btnmax.onMouseDown = "setMaxWin()";
}

function setMaxWin() {
	minCalc.visible = false;
	winStatus = "max";
	main_window.height = 204;
	maxCalc.visible = true;
	display.src = "Resources/Images/" + skin + "/display.png";
	copy.vOffset = 9;
	paste.vOffset = 9;
	displayValue.vOffset = 39;
	op1.vOffset = 39;
	for(i = 1; i < 24; i += 4) {
		for(j = 0; j < 4; j++) {
			eval("key" + (i + j) + ".vOffset = " + (43 + (i * 6)) + ";");
		}
	}
	numDisplay = new Array();
	oprDisplay = new Array();
	numDisplay[i] = new Text();
	numDisplay[i].size = "12";
	numDisplay[i].font = "courier";
	numDisplay[i].color = "#000000";
	numDisplay[i].style = "normal";
	numDisplay[i].alignment = "right";
	numDisplay[i].hOffset = "100";
	numDisplay[i].vOffset = 38;
	numDisplay[i].opacity = "255";
	numDisplay[i].data = "";

	oprDisplay[i] = new Text();
	oprDisplay[i].size = "12";
	oprDisplay[i].font = "courier";
	oprDisplay[i].color = "#000000";
	oprDisplay[i].style = "normal";
	oprDisplay[i].alignment = "right";
	oprDisplay[i].hOffset = "110";
	oprDisplay[i].vOffset = 38;
	oprDisplay[i].opacity = "200";
	oprDisplay[i].data = "";
}

function checkReset() {
	if (resetDisplay) {
		num[0] = "0";
		setOpText(" ");
		hasADec = false;
		resetDisplay = false;
	}
}

function keyDown() {
	keyEvent("down");
}

function keyUp() {
	keyEvent("up");
}

function keyEvent(action) {
	if(action == "down") {
		switch(system.event.key) {
			case ".":
				addDec();
				break;
			case ",":
				addDec();
				break;
			case "0":
				addNum(system.event.key);
				break;
			case "1":
				addNum(system.event.key);
				break;
			case "2":
				addNum(system.event.key);
				break;
			case "3":
				addNum(system.event.key);
				break;
			case "4":
				addNum(system.event.key);
				break;
			case "5":
				addNum(system.event.key);
				break;
			case "6":
				addNum(system.event.key);
				break;
			case "7":
				addNum(system.event.key);
				break;
			case "8":
				addNum(system.event.key);
				break;
			case "9":
				addNum(system.event.key);
				break;
			case "=":
				operation("eqs");
				break;
			case "+":
				operation("add");
				break;
			case "-":
				operation("sub");
				break;
			case "*":
				operation("mul");
				break;
			case "/":
				operation("div");
				break;
			case "c":
				operation("memc");
				break;
			case "r":
				operation("memr");
				break;
			case "m":
				operation("mem1");
				break;
			default:
				switch(system.event.keyString) {
					case "Return":
						operation("eqs");
						break;
					case "Enter":
						operation("eqs");
						break;
					case "Delete":
						operation("c");
						break;
					case "Backspace":
						delNum("del")
						break;
					default:
					break;
				}
				break;
		}
	} else {
		switch(system.event.keyString) {
			case "ForwardDelete":
				operation("c");
				break;
			default:
			break;
		}
	}	
}

function addDec() {
	if (!hasADec){
		checkReset();
		if(num[0].length < maxLengthNum - 1) {
			num[0] += ".";
			hasADec=true;
		} else {
			beep();
		}
		updateDisplay();
	}
}

function addNum(theNumber) {
	checkReset();
	if (num[0] == "0") {
		num[0] = "";
	}
	decparts = String(num[0]).split("\\.");
	if(decparts.length == 2) {
		decsize = decparts[1].length;
	} else {
		decsize = 0;
	}
	if(num[0].length < maxLengthNum && decsize < maxLengthDec) {
		num[0] = num[0] + "" + theNumber;
	} else {
		beep();
	}
	updateDisplay();
}

function delNum() {
	checkReset();
	num[0] = num[0].substring(0,num[0].length - 1);
	if (num[0] == "") {
		num[0] = "0";
	}
	updateDisplay();
}

function operation(theOpr) {
	if (opr[1] != "" && (theOpr == "eqs" || theOpr == "div" || theOpr == "mul" || theOpr == "add" || theOpr == "sub")) {
		setOpText("eqs");
		switch(opr[1]) {
			case 'div':
				num[0] = String(Math.round((Number(num[1]) * fpMult) / Number(num[0])) / fpMult);
				break;
			case 'mul':
				num[0] = String(Math.round((Number(num[1]) * fpMult) * Number(num[0])) / fpMult);
				break;
			case 'add':
				num[0] = String(((Number(num[1]) * fpMult) + (Number(num[0]) * fpMult)) / fpMult);
				break;
			case 'sub':
				num[0] = String(((Number(num[1]) * fpMult) - (Number(num[0]) * fpMult)) / fpMult);
				break;		
			case 'pow':
				num[0] = String(Math.pow(Number(num[1]), Number(num[0])));
		}
	}
	switch (theOpr) {
		case 'memc':
			num[2] = 0;
			break;
		case 'mem1':
			num[2] += Number(num[0]);
			resetDisplay = true;
			break;
		case 'mem2':
			num[2] -= Number(num[0]);
			resetDisplay = true;
			break;
		case 'memr':
			num[0] = num[2];
			break;
		case 'eqs':
			num[1] = "0";
			opr[1] = "";
			resetDisplay = true;
			break;
		case 'pct':
			num[0] = String( Number(num[1]) * Number(num[0]) / 100 );
			break;
		case 'chs':
			num[0] = String(Number(num[0])*-1);	
			break;
		case 'c':
			num[0] = "0";
			num[1] = "0";
			resetDisplay = false;
			hasADec = false;
			opr[1] = "";	
			break;
		case 'delNum':
			num[0] = "0";
			delNum();
			break;
		case 'inv':
			num[0] = String(1/(Number(num[0])));
			resetDisplay = true;
			break;
		default:
			num[1] = num[0];
			opr[1] = theOpr;
			resetDisplay = true;
			break;
	}
	if(theOpr == "eqs") {
		setOpText(" ");
	} else {
		setOpText(theOpr);
	}
	updateDisplay();
}

function updateDisplay(){
	if(num[0] < 0) {
		if (num[0].length > maxLengthNum){
			num[0] = num[0].substr(0,maxLengthNum + 1);
		}
	} else {
		if (num[0].length > maxLengthNum){
			num[0] = num[0].substr(0,maxLengthNum);
		}
	}
	displayValue.data = num[0];
	if(num[0] < 0) {
		displayValue.color = "#AA0000";
	} else {
		displayValue.color = "#000000";
	}
}

function setOpText(opStr) {
	switch(opStr) {
		case "add":
			op1.data = "+";
			break;
		case "sub":
			op1.data = "-";
			break;
		case "div":
			op1.data = "/";
			break;
		case "mul":
			op1.data = "*";
			break;
		case "eqs":
			op1.data = "=";
			break;
		default:
			op1.data = " ";
			break;
	}				
}

function doCopy() {
	system.clipboard = num[0];
}

function doPaste() {
	temp = Number(system.clipboard);
	if(String(temp) != "NaN") {
		num[0] = temp;
	}
	updateDisplay();
}

function setPreferences() {
	skin = preferences.skinSel.value.replace(/ /g,"_");
	setSkin();
	if (winStatus == "min") {
		setMinwin();
	} else {
		setMaxWin();
	}
}
